#version 330

in vec3 Position;
in vec3 Normal;

uniform vec4 LightDirection;
uniform vec3 LightIntensity;

uniform vec3 Kd;            // Diffuse reflectivity
uniform vec3 Ka;            // Ambient reflectivity
uniform vec3 Ks;            // Specular reflectivity
uniform float Shininess;    // Specular shininess factor

layout( location = 0 ) out vec4 FragColor;

vec3 ads( )
{
    vec3 Normal2 = normalize(Normal);
    vec3 s = normalize( vec3(LightDirection) );
    vec3 v = normalize(vec3(-Position));
    vec3 r = reflect( -s, Normal2 );

    vec3 spec = vec3(0.0,0.0,0);
    if(Shininess > 0.0) {
        spec =  Ks * pow( max( dot(r,v), 0.0 ), Shininess ) ;
    }	
    return LightIntensity * ( Ka + Kd * max( dot(s, Normal2), 0.0 ) + spec);
}

void main() {
    FragColor = vec4(ads(), 1.0);
}
